#include <nilorea.h>
#include <semaphore.h>

BITMAP *buffer = NULL ;


typedef struct Area
{
	int x , y , w , h ;
	
	sem_t start , end ;
		
}Area ;


				 
void *blur( void *param )
{
	int itx , ity , r , g , b , color ;
	
	Area *area = (Area *)param;
	
	printf( "%d to %d , %d to %d\n" , area -> x , area -> x + area -> w , area -> y , area -> y + area -> h );
		
	while( 1 )
	{
		sem_wait( &area -> start );
		
		for( itx = area -> x ; itx < area -> x + area -> w ; itx ++ )
		{
			for( ity = area -> y ; ity < area -> y + area -> h ; ity ++ )
			{
				color = getpixel( buffer , itx , ity );
				r = getr( color ) - 10 ;
				g = getg( color ) - 10 ;
				b = getb( color ) - 10 ;
				if( r < 0 ) r = 0 ;
				if( g < 0 ) g = 0 ;
				if( b < 0 ) b = 0 ;
				putpixel( buffer , itx , ity , makecol( r , g , b ) );
			}
		}
		
		sem_post( &area -> end );		
	}
	
	return NULL ;
}



int nb_thread = 0 , it = 0 , med_time = 0 ;

static pthread_t thr ;

Area *thr_area = NULL ;

int main( int argc , char *argv[] )
{

	nb_thread = strtol( argv[ 1 ] , NULL , 10 );

	Malloc( thr_area , Area , nb_thread );
		
	allegro_init();
	install_timer();
	install_mouse();
	install_keyboard();
	set_color_depth( 32 );
	set_gfx_mode( GFX_DIRECTX_WIN , 800 , 600 , 0 , 0 );
	
	buffer = create_bitmap( SCREEN_W , SCREEN_H );
	clear( buffer );
	
	for( it = 0 ; it < nb_thread ; it ++ )
	{
		thr_area[ it ] . x = ( it * SCREEN_W ) / nb_thread ;
		thr_area[ it ] . w = SCREEN_W / nb_thread ;
		thr_area[ it ] . h = SCREEN_H ;		
		thr_area[ it ] . y = 0 ;
		sem_init( &thr_area[ it ] . start , 0 , 0 );
		sem_init( &thr_area[ it ] . end   , 0 , 0 );
				
		pthread_create ( &thr, NULL, blur, &thr_area[ it ] );
	}

	
	N_TIME timer ;
	
	start_HiTimer( &timer );
	
	do{
		circlefill( buffer , mouse_x , mouse_y , 15 , makecol( rand()%255 , rand()%255 , rand()%255 ) );
	
		for( it = 0 ; it < nb_thread ; it ++ )
			sem_post( &thr_area[ it ] . start );
			
		
		for( it = 0 ; it < nb_thread ; it ++ )
			sem_wait( &thr_area[ it ] . end );
	
		if( med_time != 0 )
			textprintf_ex(buffer, font, 10, 10, makecol(255, 255, 255), 0, "Med Time duration: %d msec, fps = %d", med_time , 1000/med_time );
		
		blit( buffer , screen , 0 , 0 , 0 , 0 , SCREEN_W , SCREEN_H );

		if( med_time == 0 )
			med_time = get_msec( &timer );
		else
			med_time = ( med_time + get_msec( &timer ) ) / 2 ;

		
	}while( !key[KEY_ESC] );
		
}END_OF_MAIN()

